Wt: Wt::WDoubleValidator Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions
Wt::WDoubleValidator Class Reference

A validator for validating floating point user input. More...

`#include <Wt/WDoubleValidator>`

Inheritance diagram for Wt::WDoubleValidator:
[legend]

List of all members.

## Public Member Functions
| WDoubleValidator (WObject *parent=0)
| Creates a new double validator that accepts any double.
| WDoubleValidator (double minimum, double maximum, WObject *parent=0)
| Creates a new double validator that accepts double within the given range.
double | bottom () const
| Returns the bottom of the valid double range.
void | setBottom (double bottom)
| Sets the bottom of the valid double range.
double | top () const
| Returns the top of the valid double range.
void | setTop (double top)
| Sets the top of the valid double range.
virtual void | setRange (double bottom, double top)
| Sets the range of valid doubles.
virtual Result | validate (const WString &input) const
| Validates the given input.
virtual void | createExtConfig (std::ostream &config) const
| Provides Ext-compatible config options for client-side validation.
void | setInvalidNotANumberText (const WString &text)
| Sets the message to display when the input is not a number.
WString | invalidNotANumberText () const
| Returns the message displayed when the input is not a number.
void | setInvalidTooSmallText (const WString &text)
| Sets the message to display when the number is too small.
WString | invalidTooSmallText () const
| Returns the message displayed when the number is too small.
void | setInvalidTooLargeText (const WString &text)
| Sets the message to display when the number is too large.
WString | invalidTooLargeText () const
| Returns the message displayed when the number is too large.
virtual std::string | javaScriptValidate () const
| Creates a Javascript object that validates the input.

## Detailed Description

A validator for validating floating point user input.

This validator checks whether user input is a double in the pre-defined range.

Usage example:

     Wt::WLineEdit *lineEdit = new Wt::WLineEdit(this);
     Wt::WDoubleValidator *validator = new Wt::WDoubleValidator();
     lineEdit->setValidator(validator);
     lineEdit->setText("13.42");

### i18n

The strings used in this class can be translated by overriding the default values for the following localization keys: Wt.WDoubleValidator.NotANumber: Must be a number Wt.WDoubleValidator.TooSmall: The number must be larger than {1} Wt.WDoubleValidator.BadRange: The number must be in the range {1} to {2} Wt.WDoubleValidator.TooLarge: The number must be smaller than {1}

## Constructor & Destructor Documentation

Wt::WDoubleValidator::WDoubleValidator | ( | WObject * | parent = `0` | ) |

Creates a new double validator that accepts any double.

The validator will accept numbers using the current locale's format.

See also:
  WLocale::currentLocale()

Wt::WDoubleValidator::WDoubleValidator | ( | double | minimum,
|  | double | maximum,
|  | WObject * | parent = `0`
| ) |  |

Creates a new double validator that accepts double within the given range.

The validator will accept numbers using the current locale's format.

See also:
  WLocale::currentLocale()

## Member Function Documentation

WString Wt::WDoubleValidator::invalidNotANumberText | ( |  | ) | const

Returns the message displayed when the input is not a number.

See also:
  setInvalidNotANumberText(const WString&)

WString Wt::WDoubleValidator::invalidTooLargeText | ( |  | ) | const

Returns the message displayed when the number is too large.

See also:
  setInvalidTooLargeText(const WString&)

WString Wt::WDoubleValidator::invalidTooSmallText | ( |  | ) | const

Returns the message displayed when the number is too small.

See also:
  setInvalidTooSmallText(const WString&)

std::string Wt::WDoubleValidator::javaScriptValidate | ( |  | ) | const`[virtual]`

Creates a Javascript object that validates the input.

The JavaScript expression should evaluate to an object which contains a `validate(text)` function, which returns an object that contains the following two fields:

- fields: a boolean valid,
- a `message` that indicates the problem if not valid.

Returns an empty string if the validator does not provide a client-side validation implementationq.

Note:
  The signature and contract changed changed in Wt 3.1.9.

See also:
  inputFilter()

Reimplemented from Wt::WValidator.

void Wt::WDoubleValidator::setBottom | ( | double | bottom | ) |

Sets the bottom of the valid double range.

The default value is the minimum double value.

void Wt::WDoubleValidator::setInvalidNotANumberText | ( | const WString & | text | ) |

Sets the message to display when the input is not a number.

The default value is "Must be a number."

void Wt::WDoubleValidator::setInvalidTooLargeText | ( | const WString & | text | ) |

Sets the message to display when the number is too large.

Depending on whether bottom() and top() are real bounds, the default message is "The number must be between {1} and {2}" or "The number must be smaller than {2}".

void Wt::WDoubleValidator::setInvalidTooSmallText | ( | const WString & | text | ) |

Sets the message to display when the number is too small.

Depending on whether bottom() and top() are real bounds, the default message is "The number must be between {1} and {2}" or "The number must be larger than {1}".

void Wt::WDoubleValidator::setTop | ( | double | top | ) |

Sets the top of the valid double range.

The default value is the maximum double value.

WValidator::Result Wt::WDoubleValidator::validate | ( | const WString & | input | ) | const`[virtual]`

Validates the given input.

The input is considered valid only when it is blank for a non-mandatory field, or represents a double within the valid range.

Reimplemented from Wt::WValidator.

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator